// C Source File
// Created 18.02.03; 10:05:39

#define USE_V200              // Produce .9xz File
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files


/************************
*												*
*			PASSLOCK v1.2     *
*				 by Hofi        *
*												*
************************/

long pass = 0;
long pass1 = 0;

void getpass(int);
void drawborder(int);
// Main Function
void _main(void)
{
	int ch = 0;
	long pass10 = 0;
	long pass11 = 0;
	long savepass = 0;
	long savepass1 = 0;
	FILE *plfile;
	
	HSym sym = SymFind(SYMSTR("main\\plfile"));
	
	if(!sym.folder)
	{
		plfile = fopen("main\\plfile", "wb");
		for(ch = 0; ch < 8; ch++) fputc(0, plfile);
		fputc(0, plfile);
		fputs("PLF", plfile);
		fputc(0, plfile);
		fputc(OTH_TAG, plfile);
		fclose(plfile);
		EM_moveSymToExtMem(SYMSTR("main\\plfile"), HS_NULL);
	}
	
	plfile = fopen("main\\plfile", "rb");
	fread(&savepass, 4, 1, plfile);
	fread(&savepass1, 4, 1, plfile);
	fclose(plfile);
	
	restart: //one is none!!!!!
	drawborder(0);
	printf_xy(89, 52, "PassLock by Hofi");
	printf_xy(89, 63, "Enter: Lock Calc");
	printf_xy(89, 69, "Apps: Change Pass");
	
	ch = 0;
	while(ch != 264 && ch != 13 && ch != 265) ch = ngetchx();
	if(ch == 13)
	{
		do
		{
			clrscr();
			off();
			getpass(1);
		} while (pass != savepass || pass1 != savepass1);
	}
	
	if(ch == 265)
	{
		getpass(2);
		if(pass1 != savepass1 || pass != savepass)
		{
		 	drawborder(1);
		 	printf_xy(91, 66, "Wrong Password");
		 	ngetchx();
		 	goto restart;
		}
		getpass(3);
		if(pass == 61000000) goto restart;
		pass10 = pass;
		pass11 = pass1;
		getpass(4);
		if(pass == 61000000) goto restart;
		
		if(pass10 == pass && pass11 == pass1)
		{
			savepass = pass;
			savepass1 = pass1;
			EM_moveSymFromExtMem(SYMSTR("main\\plfile"), HS_NULL);
			plfile = fopen("main\\plfile", "r+b");
			fwrite(&savepass, 4, 1, plfile);
			fwrite(&savepass1, 4, 1, plfile);
			fclose(plfile);
			EM_moveSymToExtMem(SYMSTR("main\\plfile"), HS_NULL);
			drawborder(0);
			printf_xy(89, 52, "Password confirm");
			printf_xy(89, 66, "New Password set");
		}
		else
		{
			drawborder(1);
			printf_xy(94, 66, "Confirm failed");
		}
		ngetchx();
		goto restart;
	}
	
}	

void getpass(int x)
{
	int pos = 0;
	short kb = 0;
	pass = 0;
	pass1 = 0;
	unsigned char pastr[] = {32,32,32,32,32,32,32,32,32,32};
	
	drawborder(0);
	DrawLine(87, 63, 151, 63, A_NORMAL);
	DrawLine(87, 73, 151, 73, A_NORMAL);
	DrawLine(87, 64, 87, 72, A_NORMAL);
	DrawLine(151, 64, 151, 72, A_NORMAL);
	if(x == 1) printf_xy(85, 53, "Type your Password");
	if(x == 2) printf_xy(87, 53, "Type old Password");
	if(x == 3) printf_xy(86, 53, "Type new Password");
	if(x == 4) printf_xy(89, 53, "Confirm Password");
	
	pos = 0;
	FontSetSys(F_6x8);
	for(;;)
	{
		kb = ngetchx();
		if((kb < 97 || kb > 122) && kb != 257 && kb != 13 && kb != 264 && (kb < 48 || kb > 57)) continue;
		if(kb == 13) break;
		if(kb == 264) break;
		if(kb == 257 && pos > 0)
		{
			pos--;
			printf_xy(89+6*pos, 65, " ");
			pastr[pos] = 32;
		}
		
		if(kb != 257 && pos < 10)
		{
			printf_xy(89+6*pos, 65, "*");
			pastr[pos] = kb;
			pos++;
		}
	}
	
	if(kb != 264)
	{
		for(pos = 0; pos < 10; pos++)
		{
			if(pastr[pos] != 32 && pastr[pos] > 96) kb = pastr[pos] - 96;
			else if(pastr[pos] != 32 && pastr[pos] < 96) kb = pastr[pos] - 21;
			else kb = 0;
		
			if(pos % 2 == 0) pass += kb*pow(36,pos/2);
			else pass1 += kb*pow(36,(pos-1)/2);
		}
	}
	else
	{
		pass = 61000000;
	}
}

void drawborder(int err)
{
	int x;
	FontSetSys(F_4x6);
	for(x = 49; x < 76; x++)
	{
		DrawLine(85, x, 153, x, A_REVERSE);
	}
	if(err) printf_xy(103, 52, "!  Error  !");
	DrawLine(84, 48, 154, 48, A_NORMAL);
	DrawLine(85, 60, 153, 60, A_NORMAL);
	DrawLine(84, 76, 154, 76, A_NORMAL);
	DrawLine(84, 49, 84, 75, A_NORMAL);
	DrawLine(154, 49, 154, 75, A_NORMAL);
}

/*
PassLock by Christian Hofstadler
christian.hofstadler@utanet.at
*/


